#!/usr/bin/perl -T
use warnings;
use strict;

use lib './third-party/HTML-Tree-3.23/lib';
use lib './third-party/CSS-SAC-0.08/blib/lib';
use lib './third-party/Class-ArrayObjects-1.03/lib';
use lib '.';
use Encode;
use EncodingDetect;
use CleanHTML;

# Avoid memory exhaustion (for us or ultimate reader)
my $MAX_HTML_SIZE = 16 * 1024 * 1024;

# Figure out the encoding of the file.
# This roughly follows the algorithm of 
# http://www.whatwg.org/specs/web-apps/current-work/multipage/syntax.html
#    #determining-the-character-encoding

read STDIN, my $prefix, 512;

my $encoding = find_html_encoding($prefix);
my $document = $prefix;

read STDIN, $document, $MAX_HTML_SIZE, length $document;

{
    no warnings 'utf8'; # Encode::decode() might produce a warning, but it's okay,
                        # it's going to insert an substitution character for us.
    $document = decode($encoding, $document, $Encode::FB_DEFAULT);
}

eval {
    local $SIG{ALRM} = sub { die "timeout\n" };
    alarm 30;
    print_clean_html($document);
    alarm 0;
};
die $@ if $@;
